#pragma once

#include "Enum.h"
#include "WorkGroupModel.h"
#include "..\..\DuiLib\UIlib.h"

#define ADD_USER_FROM_CHAT					1
#define ADD_USER_FROM_NOTE					2
#define ADD_USER_FROM_DIALPAD				3
#define ADD_USER_FROM_TOPMENU_CALLTRANSFER	4
#define ADD_USER_FROM_CONFERENCECALL		5
#define ADD_USER_FROM_SMS					6


class WorkGroupModel;
class WorkGroupView;
class WorkGroupActorEvent;
class MainFrame;

class IWorkGroupController
{
public:
	IWorkGroupController(void) {};
	virtual ~IWorkGroupController(void) {};

	//virtual void ShowView(ORGVIEWTYPE eViewType) = 0;
	//virtual void CreateSearchResultView(const CString& strSearchText, const CString& strCondition) = 0;
	//virtual void Closeview() = 0;
	//virtual void CloseAddUserDlg() = 0;
	//virtual void SetViewLanguagePack() = 0;
	//virtual const CString GetMemberName(const CString& strUserID) const = 0;
	//virtual void ChangeMyStatus(GTUserStatusType eMyStatus) = 0;

	virtual void RequestWorkGroup() = 0;
	virtual void RequestORGGroup(MemberGroupListAction orgAction) = 0;
	virtual void AddORGGroupList(const GT_ORG_GROUP_DATA_LIST& list, MemberGroupListAction orgAction) = 0;
	virtual void AddWorkGroupList(const GT_ORG_GROUP_DATA_LIST& list) = 0;
	virtual void AddMemberList(const NE_MEMBER_DATA_LIST &list, MemberListAction action) = 0;

	virtual void RequestNameSearchList(NE_SEARCH_MEMBER_PARAM& searchParam) = 0;
	virtual void AddNameSearchList(const NE_SEARCH_MEMBER_DATA_LIST &list, MemberSearchAction action) = 0;

	virtual void RequestAddUserSearchList(LPCWSTR strSearchText) = 0;
	virtual void AddUserDlgSearchList(const NE_SEARCH_MEMBER_DATA_LIST &list) = 0;

	virtual void RequestWorkGroupMemberList(LPCWSTR strParentID, LPCWSTR strID) = 0;
	virtual void RequestORGGroupMemberList(LPCWSTR strParentID, LPCWSTR strID, MemberListAction action) = 0;

	virtual void UpdateMemberStatus(LPCWSTR strUserID, GTUserStatusType eUserStatus) = 0;
	virtual void UpdateMemberIPTStatus(LPCWSTR strUserID, NTIPTStatusType eIPTStatus) = 0;
	//virtual void SetReadOnly(BOOL bStatus) = 0;

	virtual void AddORGGroupFavorites(LPCWSTR strParentID, LPCWSTR strID, int nGroupID) = 0;
	virtual void AddWorkGroupFavorites(LPCWSTR strParentID, LPCWSTR strID, int nGroupID) = 0;

	virtual void ReqeustAddBuddy(const NE_MEMBER_DATA_LIST &list, int nGroupID) = 0;

	virtual void RequestORGGroupMemberListChat(LPCWSTR strParentID, LPCWSTR strID) = 0;
	virtual void MakeMemberListChat(const NE_MEMBER_DATA_LIST &list) = 0;

	virtual void RequestORGGroupMemberListMemo(LPCWSTR strParentID, LPCWSTR strID) = 0;
	virtual void RequestWorkGroupMemberListMemo(LPCWSTR strParentID, LPCWSTR strID) = 0;

	virtual void RequestORGGroupMemberListSMS(LPCWSTR strParentID, LPCWSTR strID) = 0;
	virtual void RequestWorkGroupMemberListSMS(LPCWSTR strParentID, LPCWSTR strID) = 0;

	virtual void SendMemberListMemo(const NE_MEMBER_DATA_LIST& list) = 0;
	virtual void SendMemberListSMS(const NE_MEMBER_DATA_LIST& list) = 0;

	virtual void AddFavoriteList(std::vector<wstring> &vecBuddyId, int nGroupID) = 0;

	virtual bool IsMyID(CString strID) = 0;

	virtual bool OpenAddUserDlg(CWnd *pParent, int nType) = 0;
	virtual void ClearSelectedUserVector() = 0;
	virtual const std::vector<ORG_MEMBER_DATA> GetSelectedUserVector() const = 0;
	virtual GTUserStatusType GetMemberStatus(LPCWSTR strUserID) = 0;
	virtual int GetImageIndexFromStatus(GTUserStatusType eMyStatus) = 0;
	//virtual void RefreshButtonStatus() = 0;
};

class WorkGroupController : public IWorkGroupController
{
public:
	WorkGroupController(void);
	virtual ~WorkGroupController(void);
	void InitView(MainFrame* pFrame);
	void SetORGGroupMemberList(CString strParentID, CString strID);
	void SetRequestSearch(CString strWord, MemberSearchAction eSearchAction);
	void ShowView(ORGVIEWTYPE eViewType);
	void CreateSearchResultView(CString& strSearchText);
	void Closeview(BOOL bDeteleAllData = FALSE);
	void CloseAddUserDlg();
	void ResetRetryCount();
	void SetViewLanguagePack();
	const CString GetMemberName(const CString& strUserID) const;
	void ChangeMyStatus(GTUserStatusType eMyStatus);
	
	void RequestWorkGroup();
	void RequestORGGroup(MemberGroupListAction orgAction);
	void AddORGGroupList(const GT_ORG_GROUP_DATA_LIST& list, MemberGroupListAction orgAction);
	void AddWorkGroupList(const GT_ORG_GROUP_DATA_LIST& list);
	void AddMemberList(const NE_MEMBER_DATA_LIST &list, MemberListAction action);

	void RequestNameSearchList(NE_SEARCH_MEMBER_PARAM& searchParam);
	void AddNameSearchList(const NE_SEARCH_MEMBER_DATA_LIST &list, MemberSearchAction action);

	void RequestAddUserSearchList(LPCWSTR strSearchText);
	void AddUserDlgSearchList(const NE_SEARCH_MEMBER_DATA_LIST &list);

	void RequestWorkGroupMemberList(LPCWSTR strParentID, LPCWSTR strID);
	void RequestORGGroupMemberList(LPCWSTR strParentID, LPCWSTR strID, MemberListAction action);

	void UpdateMemberStatus(LPCWSTR strUserID, GTUserStatusType eUserStatus);
	void UpdateMemberIPTStatus(LPCWSTR strUserID, NTIPTStatusType eIPTStatus);
	void SetReadOnly(BOOL bStatus);

	void AddORGGroupFavorites(LPCWSTR strParentID, LPCWSTR strID, int nGroupID);
	void AddWorkGroupFavorites(LPCWSTR strParentID, LPCWSTR strID, int nGroupID);

	void ReqeustAddBuddy(const NE_MEMBER_DATA_LIST &list, int nGroupID);

	void RequestORGGroupMemberListChat(LPCWSTR strParentID, LPCWSTR strID);
	void MakeMemberListChat(const NE_MEMBER_DATA_LIST &list);

	void RequestORGGroupMemberListMemo(LPCWSTR strParentID, LPCWSTR strID);
	void RequestWorkGroupMemberListMemo(LPCWSTR strParentID, LPCWSTR strID);

	void RequestORGGroupMemberListSMS(LPCWSTR strParentID, LPCWSTR strID);
	void RequestWorkGroupMemberListSMS(LPCWSTR strParentID, LPCWSTR strID);

	void SendMemberListMemo(const NE_MEMBER_DATA_LIST& list);
	void SendMemberListSMS(const NE_MEMBER_DATA_LIST& list);

	void AddFavoriteList(std::vector<wstring> &vecBuddyId, int nGroupID);

	bool IsMyID(CString strID);

	bool OpenAddUserDlg(CWnd *pParent, int nType);
	bool OpenAddUserDlg(WindowImplBase *pParent, int nType);
	void ClearSelectedUserVector();
	const std::vector<ORG_MEMBER_DATA> GetSelectedUserVector() const;
	GTUserStatusType GetMemberStatus(LPCWSTR strUserID);
	int GetImageIndexFromStatus(GTUserStatusType eMyStatus);
	void RefreshButtonStatus();

	trid_t GetBuddyActionTridFromWorkgroupDlg();
	CWnd* GetWorkGroupDlg();
	WorkGroupView* GetWorkView(){return m_pView;}
public:
	WorkGroupModel* m_pModel;

private:
	MainFrame *m_pMainFrame;
	WorkGroupView* m_pView;
	WorkGroupActorEvent* m_pActorEvent;
	int	m_nOrgListRetryCount;
	int	m_nWorkListRetryCount;
};
